;------------------------------------------------------------------------------
; File Name   :	melodieklingel h.frey\Melodie1.BIN
; Format      :	Binary file
; Base Address:	0000h Range: 0000h - 0800h Loaded length: 0800h
;------------------------------------------------------------------------------
; reass. V. Pohlers 30.01.2015 
;------------------------------------------------------------------------------



		cpu	Z80undoc
		org	0

;------------------------------------------------------------------------------

reset:		ld	iy, 0
		ld	c, 0FFh
		ld	de, 2000h
;
loc_9:		set	7, a
		out	(9), a
loc_D:		djnz	loc_D
		dec	de
;
sub_10:		ld	a, e		; rst 10h
		or	d
		jr	nz, loc_9
		out	(9), a
		ld	a, c
		and	3
		rlca
		ld	c, a
		ld	hl, off_1C3	; Liederlisten-Adressen
		add	hl, bc
		exx
;
loc_20:		exx			; rst 20h
		ld	a, r
		ld	b, a
loc_24:		ld	a, (hl)
		ld	iyl, a
		inc	hl
		ld	a, (hl)
		ld	iyu, a
		dec	hl
loc_2C:		bit	7, (iy+0)
		inc	iy
		jr	z, loc_2C
		bit	7, (iy+0)
		jr	nz, loc_24
		djnz	loc_2C
		exx
		ld	a, r
		and	7
		rlca
		ld	c, a
		ld	b, 0
		ld	d, b
		ld	hl, off_56
		add	hl, bc
		ld	a, (hl)
		ld	ixl, a
		inc	hl
		ld	a, (hl)
		ld	ixu, a
		ld	a, 80h ; ''
		out	(9), a
loc_55:		halt

;------------------------------------------------------------------------------
off_56:		dw loc_189
		dw loc_19A
		dw loc_17E
		dw loc_176
		dw loc_17A
		dw loc_196
		dw loc_1A1
		dw loc_1AB
;------------------------------------------------------------------------------
; Hauptprogramm
; bei Tastendruck ber NMI ausgelst
		ld	a, iyl
		or	iyu
		jr	nz, loc_7B
		inc	c
		ld	h, 0
loc_6F:		ld	b, h
loc_70:		djnz	loc_70
		ld	a, h
		and	1
		out	(9), a
		dec	h
		jr	nz, loc_6F
		rst	10h
;ROM-Test
;Prfsumme ber	Copyright-Meldung
loc_7B:		ld	b, 0Fh
		ld	hl, copyright	; "V.2/90 (c) H.Fey"
		ld	a, (hl)
loc_81:		inc	hl
		xor	(hl)
		djnz	loc_81
		cp	32h 
		jr	nz, loc_55	; HALT
;
loc_89:		ld	a, (iy+0)
		and	0Fh
		rlca
		ld	e, a
		ex	af, af'		; '
		ld	a, e
		ld	hl, tab1	; Pause
		or	a
		sbc	hl, de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ld	hl, 0
loc_9E:		ld	a, (iy+0)
		and	70h ; 'p'
		rrca
		rrca
		rrca
		rrca
		ld	b, a
		inc	b
loc_A9:		add	hl, de
		djnz	loc_A9
		bit	7, (iy+0)
		inc	iy
		jr	nz, loc_C2
		ld	a, (iy+0)
		and	0Fh
		ld	c, a
		ld	a, (iy-1)
		and	0Fh
		cp	c
		jr	z, loc_9E

loc_C2:		ex	de, hl
		ex	af, af'		;'
		ld	c, a
		ld	hl, tab2
		sbc	hl, bc
		ld	c, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, c
		jp	(hl)

;------------------------------------------------------------------------------
;Ton-Tabelle 1 (Anzahl Tonschwingungen pro Achtelnote)
		dw 234
		dw 221
		dw 209
		dw 197
		dw 186
		dw 176
		dw 166
		dw 156
		dw 148
		dw 139
		dw 132
		dw 124
		dw 117
		dw 110
		dw 104
tab1:		dw 234			; Pause
;Ton-Tabelle 2 (Sprungadressen)
		dw ton15
		dw ton14
		dw ton13
		dw ton12
		dw ton11
		dw ton10
		dw ton9
		dw ton8
		dw ton7
		dw ton6
		dw ton5
		dw ton4
		dw ton3
		dw ton2
		dw ton1
tab2:		dw pause		
;------------------------------------------------------------------------------

ton15:		ld	b, 76
		jp	(ix)
;------------------------------------------------------------------------------

ton14:		ld	b, 80
		ld	b, 80
		ld	b, b
		jp	(ix)
;------------------------------------------------------------------------------

ton13:		ld	b, 86
		jp	(ix)
;------------------------------------------------------------------------------

ton12:		ld	b, 91
		ld	b, b
		jp	(ix)
;------------------------------------------------------------------------------

ton11:		ld	b, 97
		jp	(ix)
;------------------------------------------------------------------------------

ton10:		ld	b, 103
		jp	(ix)
;------------------------------------------------------------------------------

ton9:		ld	b, 109
		nop
		jp	(ix)
;------------------------------------------------------------------------------

ton8:		ld	b, 116
		jp	(ix)
;------------------------------------------------------------------------------

ton7:		ld	b, 123
		nop
		jp	(ix)
;------------------------------------------------------------------------------

ton6:		ld	b, 131
		jp	(ix)
;------------------------------------------------------------------------------

ton5:		ld	b, 139
		jp	(ix)
;------------------------------------------------------------------------------

ton4:		ld	b, 147
		ld	b, 147
		jp	(ix)
;------------------------------------------------------------------------------

ton3:		ld	b, 156
		ld	b, 156
		jp	(ix)
;------------------------------------------------------------------------------

ton2:		ld	b, 166
		jp	(ix)
;------------------------------------------------------------------------------

ton1:		ld	b, 176
		nop
		jp	(ix)
;------------------------------------------------------------------------------

pause:		xor	a
		out	(9), a
pause0:		ld	b, 76
pause1:		djnz	pause1
		dec	de
		ld	a, d
		or	e
		jr	nz, pause0
;
loc_162:	bit	7, (iy-1)
		jp	z, loc_89
;		
		out	(9), a
		ld	de, 2000h

loc_16E:	djnz	loc_16E
		dec	de
		ld	a, d
		or	e
		jr	nz, loc_16E
		rst	20h
;
loc_176:	ld	a, 40h ; '@'
		jr	loc_180
;------------------------------------------------------------------------------

loc_17A:	bit	6, e
		jr	z, loc_189
loc_17E:	ld	a, 3Fh
loc_180:	and	e
		bit	0, e
		jr	z, loc_187
		neg
loc_187:	add	a, b
		ld	b, a
loc_189:	djnz	loc_189
		ld	a, e
loc_18C:	and	1
		out	(9), a
		dec	de
		ld	a, e
		or	d
		jr	z, loc_162
		jp	(hl)
;------------------------------------------------------------------------------

loc_196:	bit	6, e
		jr	nz, loc_189

loc_19A:	djnz	loc_19A
		ld	a, e
		rrca
		and	e
		jr	loc_18C
;------------------------------------------------------------------------------

loc_1A1:	ld	a, e
		and	3Fh
		cp	20h
		jr	nz, loc_189
		dec	de
		jr	loc_189
;------------------------------------------------------------------------------

loc_1AB:	ld	a, b
		bit	2, e
		exx
		jr	nz, loc_1BC
		sub	d
		jr	z, loc_1BD
		ld	a, 1
		jr	nc, loc_1BA
		ld	a, 0FFh

loc_1BA:	add	a, d
		ld	d, a

loc_1BC:	ld	a, d

loc_1BD:	exx
		jr	z, loc_189
		ld	b, a
		jr	loc_189
;------------------------------------------------------------------------------
off_1C3:	dw liedtab1		; 38 allgemeine	Lieder
		dw liedtab2		; 8 Frhlungslieder
		dw liedtab3		; 13 Jagdlieder
		dw liedtab4		; 22 Weihnachtslieder


; ---------------------------------------------------------------------------
; Lied-Tabellen
; Bit7 Stop-bit
; Bit6..4 Tonlnge
; Bit3..0 Tonhhe, 0000=Pause
; Ende: 2x Stop-Bit

song:		equ	$

_ton		eval	0

tonhoehe	macro hoehe,{noexpand}
		if "hoehe"=="PAUSE"
_ton		eval	0
		elseif "hoehe"=="C"
_ton		eval	1
		elseif "hoehe"=="CIS"
_ton		eval	2
		elseif "hoehe"=="D"
_ton		eval	3
		elseif "hoehe"=="DIS"
_ton		eval	4
		elseif "hoehe"=="E"
_ton		eval	5
		elseif "hoehe"=="F"
_ton		eval	6
		elseif "hoehe"=="FIS"
_ton		eval	7
		elseif "hoehe"=="G"
_ton		eval	8
		elseif "hoehe"=="GIS"
_ton		eval	9
		elseif "hoehe"=="A"
_ton		eval	10
		elseif "hoehe"=="AIS"
_ton		eval	11
		elseif "hoehe"=="H"
_ton		eval	12
		elseif "hoehe"=="C1"
_ton		eval	13
		elseif "hoehe"=="CIS1"
_ton		eval	14
		elseif "hoehe"=="D1"
_ton		eval	15
		else
		ERROR	"Falsche Tonhhe: hoehe"
		endif
		endm

ton	macro	hoehe, dauer, pause, {noexpand} 
		tonhoehe hoehe
_ton		eval	_ton+(dauer-1)*16		
		IF      "pause"=="ENDE" 
		db	_ton+080h
		ELSEIF	"pause"<>""
		db	_ton
		db	(pause-1)*16
		ELSE
		db	_ton
		ENDIF
	endm


		include	"bell.ROM.asm"
		db	0FFH

;------------------------------------------------------------------------------

		org	07F0h
copyright:	db "V.2/90 (c) H.Fey"

		end
