#!/usr/bin/perl
# vp 25.08.2009 13:25

$ARGV[0] ||= 'h:/fa-melodieklingel/fa_melodiegenerator_vp.bin';

die <<HELP unless @ARGV;
Aufruf: melo.pl eprom-dump
konvertiert die Tne zur Melodieklingel aus FA 4/86
HELP

open IN, "<$ARGV[0]" or die;
binmode IN;
read IN, $block, 2048;  # das sollte reichen
close IN;

$pos = 0x1CB;	# ab hier beginnen die Melodien
$melodie_cnt = 0;

@noten=qw(pause c cis d dis e f fis g gis a ais h c1 cis1 d1);

$OUT = $ARGV[0] . '.asm';
open OUT, ">$OUT";

# f. ASM-Makro "ton Tonhhe, Anz_Achtel(+1), [Anz_Pausen-Achtel(+1)|'Ende']"

do {{
print OUT "\n\n\n; -----------------  NEUE TABELLE -------------------\n\n\n";
++$liedtab;
printf OUT "liedtab%d:\n", $liedtab;
$melodie_cnt = 0;
print OUT "\n";

do {{
#print ($pos);
	print OUT "; $melodie_cnt. Melodie ---------------------------\n\n";
	do {{
		# Note
		$note = ord(substr($block, $pos, 1));
		
##		printf OUT "%.4x", $pos;
		print OUT "\t", 'ton ', $noten[$note & 0x0F]
			,', ', (($note & 0x70)>>4) + 1;

		# Liedende?	
		if ($note & 0x80) { 
			print OUT ', Ende';
		} else {
		# folgt Pause ?
			$note1 = ord(substr($block, $pos+1, 1));
			unless ($note1 & 0x0F) {
				print OUT ', ',(($note1 & 0x70)>>4) + 1;
				$pos++;
			}
		}
		# printf OUT "\t; %.4X: %.2X", $pos, $note;	# Ausgabe Adr. + 1. Note
		print OUT "\n";
		
		$pos++;
	}} until $note > 127;
	$melodie_cnt++;
	print OUT "\n";
}} until ord(substr($block, $pos, 1)) > 127;	
	
}} until $pos >= 0x7E9;

close OUT;

__END__

